<template>
  <el-card class="box-card" style="margin-bottom: 10px">
    <el-form>
      <el-row :gutter="10" style="margin-top: 10px">
        <el-col :xs="{span:24, tag:'mb-10'}" :sm="24" :md="24">
          <input-filter-area
            :parent-id="filterAreaParentId"
            :kabkota-id="listQuery.kabkota_id"
            :kec-id="listQuery.kec_id"
            :kel-id="listQuery.kel_id"
            :rw-id="listQuery.rw"
            @changeKabkota="changeKabkota"
            @changeKecamatan="changeKecamatan"
            @changeKelurahan="changeKelurahan"
            @changeRW="changeRW"
          />
        </el-col>
      </el-row>
      <div :class="(isActive) ? 'advance-filter-active' : 'advance-filter'" style="margin-top: 10px;">
        <el-row :gutter="10">
          <el-col :xs="{span:24, tag:'mb-10'}" :sm="12" :md="6">
            <el-form-item style="margin-bottom: 0">
              <el-input v-model.trim="listQuery.name" :placeholder="$t('users.users-fullname')" />
            </el-form-item>
          </el-col>
          <el-col v-if="listQuery.status !== 1" :xs="{span:24, tag:'mb-10'}" :sm="12" :md="6">
            <el-form-item style="margin-bottom: 0">
              <el-input v-model="listQuery.username" :placeholder="$t('users.users-username')" />
            </el-form-item>
          </el-col>
          <el-col :xs="{span:24, tag:'mb-10'}" :sm="12" :md="6">
            <el-form-item style="margin-bottom: 0">
              <el-input v-model="listQuery.phone" :placeholder="$t('users.users-phone')" />
            </el-form-item>
          </el-col>
        </el-row>
      </div>
      <el-row style="margin-top: 10px">
        <el-col>
          <el-button type="primary" size="small" style="float: right; margin: 2px;" @click="resetFilter">
            {{ $t('crud.reset') }}
          </el-button>
          <el-button type="primary" size="small" style="float: right; margin: 2px;" @click="submitSearch">
            {{ $t('crud.search') }}
          </el-button>
          <el-button v-permission="['admin', 'staffProv', 'staffKabkota', 'staffKec']" type="primary" size="small" style="float: left; margin: 2px;" @click="advanceFilter">
            <img alt="filter" src="@/assets/filter.svg" width="12" style="vertical-align: middle;">
            <span v-if="isActive">{{ $t('users.users-filter-hide') }}</span>
            <span v-else>{{ $t('users.users-filter-add') }}</span>
          </el-button>
        </el-col>
      </el-row>
    </el-form>
  </el-card>
</template>

<script>
import InputFilterArea from '@/components/InputFilterArea'
import permission from '@/directive/permission/index.js'
import checkPermission from '@/utils/permission'
import { mapGetters } from 'vuex'

export default {
  components: { InputFilterArea },
  directives: { permission },
  props: {
    listQuery: {
      type: Object,
      default: null
    }
  },

  data() {
    return {
      isActive: false
    }
  },

  computed: {
    filterAreaParentId() {
      const authUser = this.$store.state.user

      if (checkPermission(['staffKabkota'])) {
        return parseInt(authUser.kabkota_id)
      }

      if (checkPermission(['staffKec'])) {
        return parseInt(authUser.kec_id)
      }

      return null
    },

    ...mapGetters([
      'device'
    ])

  },

  methods: {
    checkPermission,

    submitSearch() {
      this.$emit('submit-search')
    },

    resetFilter() {
      this.$emit('reset-search')
    },

    changeKabkota(id) {
      this.$emit('change-kabkota', id)
    },

    changeKecamatan(id) {
      this.$emit('change-kecamatan', id)
    },

    changeKelurahan(id) {
      this.$emit('change-kelurahan', id)
    },

    changeRW(id) {
      this.$emit('change-rw', id)
    },

    advanceFilter() {
      if (this.isActive) {
        this.isActive = false
      } else {
        this.isActive = true
      }
    }
  }
}
</script>

<style>
  .advance-filter-active {
    display: block;
  }
  .advance-filter {
    display: none;
  }
  .last-access-start {
    width: 100% !important;
  }
  .last-access-end {
    width: 100% !important;
  }
</style>
